## unifont 16.0.04

=== Makefile ===
#
# unifoundry.com utilities for GNU Unifont
#
# Typing "make && make install" will make and
# install the binary programs, man pages, and
# documentation files.
#
# To build only the font from scratch, use
# "cd font ; make"
#
SHELL = /bin/sh
INSTALL = install
GZFLAGS = -f -9 -n

PACKAGE = "unifont"
VERSION = 16.0.04

#
# The settings below will install software, man pages, and documentation
# in /usr.  To install in a different location, modify USRDIR to your
# liking.  The commented-out example for USRDIR installs files in
# subdirectories under /usr/local instead.
#
USRDIR = usr
# USRDIR = usr/local
PREFIX = $(DESTDIR)/$(USRDIR)
PKGDEST = $(PREFIX)/share/unifont

HEXFILES = hangul-syllables.hex plane00-nonprinting.hex pua.hex spaces.hex \
	   plane00-unassigned.hex unifont-base.hex wqy.hex

#
# HEXWIDTH and ZEROWIDTH are for forming wcwidth values.
#
HEXWIDTH = font/plane00/hangul-syllables.hex \
	   font/plane00/spaces.hex \
	   font/plane00/unifont-base.hex \
	   font/plane00/wqy.hex \
	   font/plane00/custom00.hex \
	   font/plane00/plane00-nonprinting.hex \
	   font/plane00csur/plane00csur.hex \
	   font/plane00csur/plane00csur-spaces.hex \
	   font/plane01/plane01.hex \
	   font/plane01/plane01-nonprinting.hex \
	   font/plane0Fcsur/plane0Fcsur.hex

ZEROWIDTH = font/plane00/plane00-combining.txt \
	    font/plane00csur/plane00csur-combining.txt \
	    font/plane01/plane01-combining.txt \
	    font/plane0E/plane0E-combining.txt \
	    font/plane0Fcsur/plane0Fcsur-combining.txt

TEXTFILES = ChangeLog INSTALL NEWS README

#
# Whether to build the font or not (default is not).
# Set to non-null value to build font files.
#
BUILDFONT=

#
# Whether to install man pages uncompressed (COMPRESS = 0) or
# compressed (COMPRESS != 0).
#
COMPRESS = 1

all: bindir libdir docdir doxdir buildfont
	@echo "Make is done."

#
# Build a distribution tarball.
#
dist: distclean
	(cd .. && tar chf $(PACKAGE)-$(VERSION).tar $(PACKAGE)-$(VERSION) && \
		gzip $(GZFLAGS) $(PACKAGE)-$(VERSION).tar)

bindir: bin

bin: src/*
	set -e && $(MAKE) -C src

#
# Conditionally build the font, depending on the value of BUILDFONT.
# To build the font unconditionally, use the "fontdir" target below.
#
buildfont: bindir
	if [ x$(BUILDFONT) != x ] ; \
        then \
           set -e && $(MAKE) -C font ; \
        fi

#
# Not invoked automatically; the font files are taken from
# font/precompiled by default.
#
fontdir:
	set -e && $(MAKE) -C font

#
# Library directory, which only contains wchardata.c with
# functions for determining string and letter widths.
#
libdir: lib/wchardata.c

#
# texinfo documentation files.
#
docdir:
	set -e && $(MAKE) -C doc

#
# Doxygen HTML and LaTeX/PDF source code documentation.
#
doxdir: doxygen

#
# Generate doxygen/html/* and doxygen/latex/refman.pdf
#
doxygen: Doxyfile src/*.c src/*.h src/*.dox
	doxygen Doxyfile
	-(cd doxygen/latex ; make && mv refman.pdf ../unifont-doxy.pdf && \
	 make clean)
	touch $@

mandir:
	set -e && $(MAKE) -C man

precompiled:
	set -e && $(MAKE) -C font precompiled

#
# Create lib/wchardata.c.  If you want to also build the object file
# wchardata.o, uncomment the last line
#
lib/wchardata.c: $(HEXWIDTH) $(ZEROWIDTH) bin
	install -m0755 -d lib
	sort $(HEXWIDTH) > unifonttemp.hex
	sort $(ZEROWIDTH) > combiningtemp.txt
	bin/unigenwidth unifonttemp.hex combiningtemp.txt > lib/wchardata.c
	\rm -f unifonttemp.hex combiningtemp.txt
#	(cd lib && $(CC) $(CFLAGS) -c wchardata.c && chmod 644 wchardata.o )

install: bindir libdir docdir doxdir
	$(MAKE) -C src install PREFIX=$(PREFIX)
	$(MAKE) -C man install PREFIX=$(PREFIX) COMPRESS=$(COMPRESS)
	$(MAKE) -C font install PREFIX=$(PREFIX) DESTDIR=$(DESTDIR)
	install -m0755 -d $(PKGDEST)
	install -m0644 -p $(TEXTFILES) doc/unifont.txt doc/unifont.info \
	                               doc/unifont.pdf $(PKGDEST)
	for i in $(TEXTFILES) unifont.txt unifont.info ; do \
	    gzip $(GZFLAGS) $(PKGDEST)/$$i ; \
	done
	install -m0644 -p lib/wchardata.c $(PKGDEST)
	install -m0644 -p font/plane00/plane00-combining.txt $(PKGDEST)
	(cd doxygen ; tar chf - html unifont-doxy.pdf) | \
	   (cd $(PKGDEST) ; tar xpf -)
	# If "make" wasn't run before, font/compiled won't exist.
	if [ ! -d font/compiled ] ; then \
	   install -m0644 -p font/precompiled/unifont-$(VERSION).hex     $(PKGDEST)/unifont.hex     && \
	   install -m0644 -p font/precompiled/unifont_jp-$(VERSION).hex  $(PKGDEST)/unifont_jp.hex  && \
	   install -m0644 -p font/precompiled/unifont_all-$(VERSION).hex $(PKGDEST)/unifont_all.hex && \
	   install -m0644 -p font/precompiled/unifont-$(VERSION).bmp     $(PKGDEST)/unifont.bmp ; \
	else \
	   install -m0644 -p font/compiled/unifont-$(VERSION).hex        $(PKGDEST)/unifont.hex     && \
	   install -m0644 -p font/compiled/unifont_jp-$(VERSION).hex     $(PKGDEST)/unifont_jp.hex  && \
	   install -m0644 -p font/compiled/unifont_all-$(VERSION).hex    $(PKGDEST)/unifont_all.hex && \
	   install -m0644 -p font/compiled/unifont-$(VERSION).bmp        $(PKGDEST)/unifont.bmp ; \
	fi
	gzip $(GZFLAGS) $(PKGDEST)/unifont.bmp

clean:
	$(MAKE) -C src  clean
	$(MAKE) -C doc  clean
	$(MAKE) -C man  clean
	$(MAKE) -C font clean
	\rm -rf *~

#
# The .DS files are created under Mac OS X
#
distclean:
	$(MAKE) -C src  distclean
	$(MAKE) -C doc  distclean
	$(MAKE) -C man  distclean
	$(MAKE) -C font distclean
	\rm -rf bin lib
	\rm -f unifonttemp.hex
	\rm -rf *~
	\rm -rf .DS* ._.DS*

.PHONY: all dist buildfont fontdir libdir docdir doxdir mandir \
	truetype precompiled install clean distclean

=== font/Makefile ===
#
# Makefile to build a version of GNU Unifont with the
# unifoundry.com GNU Unifont utilities.  This Makefile
# converts unifont-$(VERSION).hex and related files into a final
# GNU Unifont font file.
#
# This software is released under version 2.0 of the GNU Public License,
# or (at your option) a later version of the GPL.
#
# Paul Hardy, 7 July 2008
#
# commands will be interpreted with the Bourne Shell
#
SHELL = /bin/sh
INSTALL = install
GZFLAGS = -f -9 -n
FONTFORGE = fontforge
PERL = 
#compiled

PACKAGE = "unifont"
VERSION = 16.0.04

COPYRIGHT = "Copyright (C) 1998-2025 Roman Czyborra, Paul Hardy, \
Qianqian Fang, Andrew Miller, Johnnie Weaver, David Corbett, \
Nils Moskopp, Rebecca Bettencourt, Minseo Lee, Ho-Seok Ee, et al. \
License: SIL Open Font License version 1.1 and GPLv2+: \
GNU GPL version 2 or later <http://gnu.org/licenses/gpl.html> \
with the GNU Font Embedding Exception."

#
# Path to local unifont-bin utilities.  If your system doesn't
# use GNU's version of "make", use the first BINDIR definition.
# If using GNU's "make", use the second BINDIR definition.
#
BINDIR = ../bin
# BINDIR = $(CURDIR)/../bin
#
# The top-level directories for installing fonts on the system,
# and the installation directories for PCF and TrueType fonts.
#
USRDIR = usr
# USRDIR = usr/local

PREFIX      = $(DESTDIR)/$(USRDIR)
CONSOLEDEST = $(PREFIX)/share/consolefonts
FONTDEST    = $(PREFIX)/share/fonts
PCFDEST     = $(FONTDEST)/X11/misc
TTFDEST     = $(FONTDEST)/truetype/unifont
OTFDEST     = $(FONTDEST)/opentype/unifont
#
# destination directory for compiled fonts
#
COMPILED_DIR = compiled
#
# destination directory for .bmp or .png representation of font
#
BMPDIR = $(COMPILED_DIR)/bmp
PNGDIR = $(COMPILED_DIR)/png

# Choose one graphics format or neither.
GRAPHICS=png
# GRAPHICS=bmp
#
# Directory with original unifont-$(VERSION).hex files
#
HEXDIR = plane00
#
# These are the files for building GNU Unifont with the Qianqian Fang's
# Wen Quan Yi CJK ideographs.  This version provides complete coverage
# of the Unicode Basic Multilingual Plane.
#
# If you don't want to include blank glyphs in unassigned code points,
# uncomment the UNASSIGNED definition or override from the make command line.
#
UNASSIGNED = $(HEXDIR)/plane00-unassigned.hex
# UNASSIGNED =

#
# Non-printing glyphs.  There are only about 100 of these, and many end
# users do want to print representations of these glyphs, so they are
# included as an optional assignment.
#
NONPRINTING = $(HEXDIR)/plane00-nonprinting.hex
# NONPRINTING =

#
# Private Use Area glyphs.  Uncomment one of the lines below to include:
#
#   - Four-digit hexadecimal glyphs "pua.hex"
#   - Hangul Johab 6/3/1 glyphs in "hangul-base.hex", or
#   - Override PUA definition from the make command line.
#
# Note that selecting any of these options will override the use
# of the ConScript Unicode Registry (CSUR) and Under CSUR (UCSUR)
# glyphs from being part of a Unifont PUA section in a font.
#
HANGUL_PUA = $(HEXDIR)/hangul/hangul-base.hex
#
# PUA = $(HEXDIR)/pua.hex
# PUA = $(HANGUL_PUA)
PUA = 

# The remaining .hex files will be constant unless a customized font
# is being built.  Note that COPYLEFT contains the encoding for U+01F12F,
# which is in Unicode Plane 1 rather than Plane 0.  It is included in the
# base Plane 0 Unifont TTF font as an exception because of its significance.
UNIFONTBASE = $(HEXDIR)/unifont-base.hex
CJK         = $(HEXDIR)/wqy.hex
HANGUL      = $(HEXDIR)/hangul-syllables.hex
SPACES      = $(HEXDIR)/spaces.hex
CUSTOM00    = $(HEXDIR)/custom00.hex
COPYLEFT    = $(HEXDIR)/copyleft.hex

UNIFILES = $(UNIFONTBASE) $(CJK) $(HANGUL) $(SPACES) $(UNASSIGNED) \
	   $(NONPRINTING) $(PUA) $(CUSTOM00)

#
# All Plane 0 glyphs except for the JIS X 0213 glyph file, for
# creating the unifont_sample file.
#
PLANE0 = copyleft.hex custom00.hex hangul-syllables.hex \
	omit.hex plane00-nonprinting.hex plane00-unassigned.hex \
	pua.hex spaces.hex unifont-base.hex wqy.hex

#
# JIS X 0213 hex files for Japanese.  The plane00 file contains glyphs
# that will replace those in the default Chinese version of Unifont.
#
# JISHEX = plane00/izmg16-plane00.hex plane02/izmg16-plane02.hex
# PLANE_2_JP_HEX = plane02/izmg16-plane02.hex
# PLANE_2_ZH_HEX = plane02/zh-plane02.hex
# PLANE_3_ZH_HEX = plane03/zh-plane03.hex
#
# Plane 2 and Plane 3 Japanese (JP_UPPER_SUBSET_HEX) and Chinese (ZH_UPPER_SUBSET_HEX)
# collections.
#
JP_UPPER_SUBSET_HEX = $(COMPILED_DIR)/jp-upper-subset.hex
ZH_UPPER_SUBSET_HEX = $(COMPILED_DIR)/zh-upper-subset.hex
JP_UPPER_SUPERSET_HEX = $(COMPILED_DIR)/jp++.hex
ZH_UPPER_SUPERSET_HEX = $(COMPILED_DIR)/zh++.hex

#
# Planes 1 through 14 (0x0E) are ordinary;
# Planes 15 (0x0F) and 16 (0x10) are Private Use Area
#
UPPER_FILES = plane0[1E]/*.hex

#
# Definitions for building unifont_all-$(VERSION).hex
#
ALL_HEX_PLANE00 =     plane00/hangul-syllables.hex \
	              plane00/plane00-nonprinting.hex \
	              plane00/plane00-unassigned.hex \
	              plane00/spaces.hex \
	              plane00/unifont-base.hex \
	              plane00/wqy.hex
ALL_HEX_PLANE00CSUR = plane00csur/plane00csur-nonprinting.hex \
	              plane00csur/plane00csur-spaces.hex \
	              plane00csur/plane00csur-unassigned.hex \
	              plane00csur/plane00csur.hex
ALL_HEX_PLANE01 =     plane01/plane01-nonprinting.hex \
	              plane01/plane01-noscript.hex \
	              plane01/plane01-space.hex \
	              plane01/plane01-unassigned.hex \
	              plane01/plane01.hex
ALL_HEX_PLANE02 =     plane02/zh-plane02.hex \
	              plane02/izmg16-plane02.hex
ALL_HEX_PLANE03 =     plane03/zh-plane03.hex
ALL_HEX_PLANE0E =     plane0E/plane0E-nonprinting.hex \
	              plane0E/plane0E-unassigned.hex \
	              plane0E/plane0E.hex
ALL_HEX_PLANE0FCSUR = plane0Fcsur/plane0Fcsur-nonprinting.hex \
	              plane0Fcsur/plane0Fcsur-spaces.hex \
	              plane0Fcsur/plane0Fcsur-unassigned.hex \
	              plane0Fcsur/plane0Fcsur.hex
ALL_HEX_LOWER = $(ALL_HEX_PLANE00) $(ALL_HEX_PLANE00CSUR)
ALL_HEX_UPPER = $(ALL_HEX_PLANE01) $(ALL_HEX_PLANE02) $(ALL_HEX_PLANE03) \
	        $(ALL_HEX_PLANE0E) $(ALL_HEX_PLANE0FCSUR)


#
# Location of the file containing a list of Unicode combining characters.
#
COMBINING = plane00/plane00-combining.txt

UPPER_COMBINING = plane0[1-E]/*combining.txt

#
# All combining information files.
#
COMBINING_FILES = plane00/plane00-combining.txt \
	          plane00csur/plane00csur-combining.txt \
	          plane01/plane01-combining.txt \
	          plane0E/plane0E-combining.txt \
	          plane0Fcsur/plane0Fcsur-combining.txt

#
# Location of OpenType (OTF) & TrueType (TTF)  source directories,
# where OTF and TTF fonts are built, respectively.
#
OTFSRC = otfsrc
TTFSRC = ttfsrc


all: compiled

compiled: $(HANGUL) $(UNIFILES) $(COMBINING) $(UPPER_FILES) $(UPPER_COMBINING)
	$(MAKE) compiled-files
	touch $@

#
# Only use PSF target if on GNU/Linux, not on BSD, because
# a BSD console font only allows 256 code points, not 512.
#
PSF = psf
# PSF =
# compiled-files: pcf $(PSF) $(GRAPHICS) opentype truetype bigpic coverage
compiled-files: pcf $(PSF) $(GRAPHICS) opentype bigpic thumbnails coverage
	sed -e 's/<a /<a target="blank" /g' index.html | \
	   sed -e 's/png/$(GRAPHICS)/g' > $(COMPILED_DIR)/index.html
	cat $(COMBINING_FILES) \
	    > $(COMPILED_DIR)/unifont-combining-$(VERSION).txt

#
# Build the aggregate .hex font files
#
hex: hex-stamp

$(HANGUL): $(HANGUL_PUA)
	(cd $(HEXDIR)/hangul && make && install -m 0644 hangul-syllables ..)

hex-stamp:
	if [ ! -d $(BINDIR) ] ; then \
	   (cd .. ; make) ; \
	fi
	if [ ! -d $(COMPILED_DIR) ] ; then \
	   mkdir -p $(COMPILED_DIR) ; \
	fi
	sort $(UNIFILES) > $(COMPILED_DIR)/unifont-$(VERSION).hex
	# Create Chinese and Japanese versions of Plane 2 and Plane 3 glyphs.
	./build-cjk-upper
	# Create Unifont sample version with combining circles.
	(cd $(HEXDIR) && sort $(PLANE0)) | \
	  egrep -v "^FFF[EF]" | grep -v "^01F12F:" | \
	   $(BINDIR)/unigencircles $(COMBINING) plane00/plane00-nonprinting.hex \
	   > $(COMPILED_DIR)/unifont_sample-$(VERSION).hex
	# Prepare upper-plane glyphs.
	sort $(UPPER_COMBINING) > $(COMPILED_DIR)/upper_combining.txt
	sort plane0[1-E]/plane*-nonprinting.hex \
	   > $(COMPILED_DIR)/upper_nonprinting.hex
	# Generate files in plane01/all directory to create font sample book.
	(cd plane01 && make)
	sort plane01/plane01-all.hex plane02/zh-plane02.hex \
		plane0[3-E]/*.hex | \
	   grep -v "^0020:"       | \
	   egrep -v "^..FFF[EF]"  | \
	   $(BINDIR)/unigencircles $(COMPILED_DIR)/upper_combining.txt \
	   $(COMPILED_DIR)/upper_nonprinting.hex \
	   > $(COMPILED_DIR)/unifont_upper_sample-$(VERSION).hex
	# Create a .hex file with CSUR glyphs, without combining circles
	(cd plane00csur && make)
	grep -v "^0020:" plane00csur/plane00csur-all.hex | \
	   sort - $(COMPILED_DIR)/unifont-$(VERSION).hex \
	      > $(COMPILED_DIR)/unifont_csur_lower-$(VERSION).hex
	# Create a .hex file with only CSUR glyphs from all planes
	sort plane00csur/plane00csur-all.hex | sed -e 's/^/00/' \
	   > $(COMPILED_DIR)/unifont_csur-$(VERSION).hex
	(cd plane0Fcsur && make)
	sort plane0[1-F]csur/*.hex | grep -v "^0020:" \
	   >> $(COMPILED_DIR)/unifont_csur-$(VERSION).hex
	# Create a .hex file with all CSUR glyphs, with combining circles
	sort plane00csur/plane00csur-combining.txt \
	   >  $(COMPILED_DIR)/csur_combining.txt
	sort plane0[1-F]csur/plane0[1-F]csur-combining.txt \
	   >> $(COMPILED_DIR)/csur_combining.txt
	$(BINDIR)/unigencircles \
	     $(COMPILED_DIR)/csur_combining.txt \
	     plane00/plane00-nonprinting.hex \
	   < $(COMPILED_DIR)/unifont_csur-$(VERSION).hex \
	   > $(COMPILED_DIR)/unifont_csur_sample-$(VERSION).hex
	# Build Japanese version with glyphs from JIS X 0213:2004
	awk -F: -f unipatch-hex.awk $(COMPILED_DIR)/unifont-$(VERSION).hex \
	   plane00/izmg16-plane00.hex | sort |\
	   tee $(COMPILED_DIR)/unifont_jp-$(VERSION).hex | \
	   $(BINDIR)/unigencircles $(COMBINING) plane00/plane00-nonprinting.hex \
              > $(COMPILED_DIR)/unifont_jp_sample-$(VERSION).hex
	# Build upper plane hex files with Chinese & Japanese variants.
	cp  plane01/plane01-all.hex     $(COMPILED_DIR)/unifont_upper-$(VERSION).hex
	cat $(ZH_UPPER_SUPERSET_HEX) >> $(COMPILED_DIR)/unifont_upper-$(VERSION).hex
	sort -u $(ALL_HEX_PLANE0E)   >> $(COMPILED_DIR)/unifont_upper-$(VERSION).hex
	cat $(JP_UPPER_SUBSET_HEX)   >> $(COMPILED_DIR)/unifont_jp-$(VERSION).hex
	touch $@

#
# Build a BDF font file from the final .hex files.
#
bdf: hex bdf-stamp

bdf-stamp:
	# First make the default BDF font.  The font name will be "unifont".
	$(BINDIR)/hex2bdf --version "$(VERSION)" --copyright $(COPYRIGHT) \
	   $(COMPILED_DIR)/unifont-$(VERSION).hex \
	   >$(COMPILED_DIR)/unifont-$(VERSION).bdf
	gzip $(GZFLAGS) <$(COMPILED_DIR)/unifont-$(VERSION).bdf \
	           >$(COMPILED_DIR)/unifont-$(VERSION).bdf.gz
	# Now make a version with combining circles.  The font name
	# will be "unifont_sample" instead of "unifont" to distinguish
	# it from the default font.
	$(BINDIR)/hex2bdf --font "Unifont Sample" \
	   --version "$(VERSION)" --copyright $(COPYRIGHT) \
	     $(COMPILED_DIR)/unifont_sample-$(VERSION).hex \
	   > $(COMPILED_DIR)/unifont_sample-$(VERSION).bdf
	gzip $(GZFLAGS) <$(COMPILED_DIR)/unifont_sample-$(VERSION).bdf \
	           >$(COMPILED_DIR)/unifont_sample-$(VERSION).bdf.gz
	# Font with ConScript Unicode Registry (CSUR) glyphs added
	$(BINDIR)/hex2bdf --font "Unifont CSUR" \
	   --version "$(VERSION)" --copyright $(COPYRIGHT) \
	     $(COMPILED_DIR)/unifont_csur_lower-$(VERSION).hex \
	   > $(COMPILED_DIR)/unifont_csur-$(VERSION).bdf
	gzip $(GZFLAGS) <$(COMPILED_DIR)/unifont_csur-$(VERSION).bdf \
	           >$(COMPILED_DIR)/unifont_csur-$(VERSION).bdf.gz
	# Font with glyphs above Plane 0
	$(BINDIR)/hex2bdf --font "Unifont Upper" \
	   --version "$(VERSION)" --copyright $(COPYRIGHT) \
	     $(COMPILED_DIR)/unifont_upper-$(VERSION).hex \

=== man/Makefile ===

SHELL = /bin/sh
GZFLAGS = -f -9 -n

MAN1PAGES = bdfimplode.1 hex2bdf.1 hex2otf.1 hex2sfd.1 \
	hexbraille.1 hexdraw.1 hexmerge.1 hexkinya.1 \
	johab2syllables.1 johab2ucs2.1 \
	unibdf2hex.1 unibmp2hex.1 unibmpbump.1 unicoverage.1 unidup.1 \
	unifont1per.1 unifontpic.1 unifontchojung.1 unifontksx.1 \
	unigen-hangul.1 unigencircles.1 unigenwidth.1 unihex2bmp.1 \
	unihex2png.1 unihexfill.1 unihexgen.1 unihexpose.1 unihexrotate.1 \
	unijohab2html.1 unipagecount.1 unipng2hex.1 unifont-viewer.1

MAN5PAGES = unifont.5 unifont-johab631.5

#
# $(PREFIX) is defined in the top-level Makefile or on the command line
# to override the setting below.
#
PREFIX = /usr
INSTALLDIR = $(PREFIX)/share/man

#
# Set "COMPRESS = 0" to install uncompressed man pages (the default), or
# override on the command line.
#
# Set "COMPRESS = 1" or anything else non-zero to install gzipped man pages.
#
COMPRESS = 1

all:

install:
	install -m0755 -d $(INSTALLDIR)
	install -m0755 -d $(INSTALLDIR)/man1
	install -m0755 -d $(INSTALLDIR)/man5
	for i in $(MAN1PAGES) ; do \
	   if [ $(COMPRESS) = 0 ] ; then \
	      install -m0644 $(MAN1PAGES) $(INSTALLDIR)/man1 ; \
	   else \
	      gzip $(GZFLAGS) < $$i >$$i.gz && \
	      chmod 644 $$i.gz && \
	      mv $$i.gz $(INSTALLDIR)/man1 ; \
	   fi \
	done
	for i in $(MAN5PAGES) ; do \
	   if [ $(COMPRESS) = 0 ] ; then \
	      install -m0644 $(MAN5PAGES) $(INSTALLDIR)/man5 ; \
	   else \
	      gzip $(GZFLAGS) < $$i >$$i.gz && \
	      chmod 644 $$i.gz && \
	      mv $$i.gz $(INSTALLDIR)/man5 ; \
	   fi \
	done

clean:
	\rm -f *~

distclean: clean

.PHONY: all install clean distclean

=== src/Makefile ===

SHELL = /bin/sh

CC = gcc
C99 = $(CC) -std=c99

CFLAGS = -g -O2 -Wall

LOCALBINDIR = ../bin

#
# INSTALL can be defined on the command line to override
# the next definition.  This is only applied to C programs
# to allow INSTALL="install -s" to be specified.  Perl
# programs just use "install", not "$(INSTALL)".
#
INSTALL=install
#
# $(PREFIX) is defined in top-level directory, so don't do a
# 'make install' within this directory -- do it from above.
#
INSTALLDIR = $(PREFIX)/bin

#
# Programs written in C.
#
CPROGS = hex2otf johab2syllables unibmp2hex unicoverage unidup \
	 unibdf2hex unibmpbump unifont1per unifontpic unigen-hangul \
	 unigencircles unigenwidth unihex2bmp unihexgen unihexpose \
	 unijohab2html unipagecount

#
# Programs written in Perl.
#
# The programs johab2ucs2, unifontchojung, and unifontksx are
# only used for generation of Hangul syllables.
#
PPROGS = bdfimplode hex2bdf hex2sfd hexbraille hexdraw hexkinya hexmerge \
	 johab2ucs2 unifontchojung unifontksx unihex2png unihexfill \
	 unihexrotate unipng2hex unifont-viewer

PROGS = $(CPROGS) $(PPROGS)


all: $(CPROGS) bin

#
# Earlier Unifont C programs written before hex2otf follow C89 syntax.
# hex2otf follows C99 syntax, so compile with a C99 flag for older gcc
# versions.   Notably, several platforms have remained with gcc 4.2.1
# because it was the last version of gcc licensed under GPLv2.  In
# the future, the "-std=c99" flag could be added to the global CFLAGS
# declaration at the beginning of this file.
#
hex2otf: hex2otf.c hex2otf.h
	$(C99) $(CFLAGS) hex2otf.c -o hex2otf

unihexpose: unihexpose.o unifont-support.o
	$(CC) $(CFLAGS) unihexpose.o unifont-support.o -o unihexpose

unijohab2html: hangul.h unihangul-support.o unijohab2html.o
	$(CC) $(CFLAGS) unijohab2html.o unihangul-support.o -o unijohab2html

johab2syllables: hangul.h unihangul-support.o johab2syllables.o
	$(CC) $(CFLAGS) johab2syllables.o unihangul-support.o -o johab2syllables

unigen-hangul: hangul.h unihangul-support.o unigen-hangul.o
	$(CC) $(CFLAGS) unigen-hangul.o unihangul-support.o -o unigen-hangul

bin: bin-stamp

bin-stamp: $(CPROGS) $(PPROGS)
	install -m0755 -d $(LOCALBINDIR)
	$(INSTALL) -m0755 $(CPROGS) $(LOCALBINDIR)
	$(INSTALL) -m0755 $(PPROGS) $(LOCALBINDIR)
	# \rm -f $(CPROGS)
	touch $@

# install: $(CPROGS)

install: bin
	if [ x$(PREFIX) = x ] ; \
	then \
	   @echo "Fatal error: PREFIX directory is not defined." && \
	   @echo "Run 'make install' from top-level directory" && \
	   exit 1 ; \
	fi
	install -m0755 -d $(INSTALLDIR)
	set -e && \
	   cd $(LOCALBINDIR) && \
	   $(INSTALL) -m0755 $(CPROGS) $(INSTALLDIR)
	set -e && \
	   cd $(LOCALBINDIR) && \
	   $(INSTALL) -m0755 $(PPROGS) $(INSTALLDIR)

#
# The *.exe is for cygwin; it does nothing elsewhere.
# The *.dSYM is for Mac OS X.
#
clean:
	\rm -f $(CPROGS) *.o
	\rm -f *~
	\rm -f *.exe
	\rm -rf *.dSYM

distclean: clean
	\rm -f bin-stamp *~

.PHONY: all bin install clean distclean

=== font/otfsrc/Makefile ===

SHELL = /bin/sh

BINDIR = ../../bin

#
# Default values, if not set on the command line when make is invoked:
#
# FONTFILE:  Prefix of the file name for input and output files.
# FONTNAME:  Name of the font inside a TTF file.
# PSNAME:    PostScript name of the font inside a TTF file; can't have spaces.
# COMBINING: Prefix of the file containing a list of combining characters.
#
FONTFILE=unifont
FONTNAME=Unifont
PSNAME=Unifont
COMBINING=combining

#
# Designate language for TrueType text as American English.
#
#
TTF_LANG = 0x409
#
# The PostScript name of a font can't contain spaces--remove them.
# Could also use bash string replacement if you know you're using bash.
#

COPYRIGHT = "Copyright © 1998-2025 Roman Czyborra, Paul Hardy, \
Qianqian Fang, Andrew Miller, Johnnie Weaver, David Corbett, \
Nils Moskopp, Rebecca Bettencourt, Ho-Seok Ee, et al."

VERSION = 16.0.04

all: otf

#
# Set the location of the hex2otf binary executable.
#
HEX2OTF = $(BINDIR)/hex2otf

#
# Create the OpenType font file.  In case $(COMBINING).txt does not
# exist, touch the filename.  Then run hex2otf.
#	$(HEX2OTF) hex=$(FONTFILE).hex pos=otf-$(COMBINING).txt \
#	touch otf-$(COMBINING).txt
#
otf: $(FONTFILE).hex $(HEX2OTF)
	@echo "Creating OpenType font."
	$(HEX2OTF) \
	   hex=$(FONTFILE).hex \
	   pos=$(COMBINING).txt \
	   format=cff,gpos,gsub \
	   0=$(COPYRIGHT) \
	   1="$(FONTNAME)" \
	   2="Regular" \
	   3="$(PSNAME)-$(VERSION).otf" \
	   4="$(FONTNAME)" \
	   5="Version $(VERSION)" 6="$(PSNAME)" \
	   11="https://unifoundry.com/unifont/" \
	   13="Dual license: SIL Open Font License version 1.1, and GNU GPL version 2 or later with the GNU Font Embedding Exception." \
	   14="https://gnu.org/licenses/gpl.html, https://scripts.sil.org/OFL" \
	   out=$(FONTFILE).otf

#
# Delete files copied into this directory to build OpenType fonts.
#
clean:
	rm -f *.hex *.txt

#
# Delete files created within this directory while building OpenType fonts.
#
distclean: clean
	rm -f *.otf

.PHONY: all otf clean distclean

=== font/ttfsrc/Makefile ===

SHELL = /bin/sh

BINDIR = ../../bin

FONTFORGE = fontforge

#
# Default values, if not set on the command line when make is invoked:
#
# FONTFILE:  Prefix of the file name for input and output files.
# FONTNAME:  Name of the font inside a TTF file.
# PSNAME:    PostScript name of the font inside a TTF file; can't have spaces.
# COMBINING: Prefix of the file containing a list of combining characters.
#
FONTFILE=unifont
FONTNAME=Unifont
PSNAME=Unifont
COMBINING=combining

#
# Designate language for TrueType text as American English.
#
#
TTF_LANG = 0x409
#
# The PostScript name of a font can't contain spaces--remove them.
# Could also use bash string replacement if you know you're using bash.
#

COPYRIGHT = "Copyright © 1998-2025 Roman Czyborra, Paul Hardy, \
Qianqian Fang, Andrew Miller, Johnnie Weaver, David Corbett, \
Nils Moskopp, Rebecca Bettencourt, Ho-Seok Ee, et al."

VERSION = 16.0.04

#
# How to build unifont.ttf from GNU Unifont's unifont.hex
# -------------------------------------------------------
# Written by Luis Alejandro Gonzalez Miranda - http://www.lgm.cl/
#

#
# 2008 - Paul Hardy created this Makefile from Luis' original
# howto-build.sh and other bash scripts.  Those original scripts
# don't appear in this archive, but they can be retrieved from
# http://www.lgm.cl/.
#

# First of all, you need a Perl interpreter and FontForge.
#
# I don't remember all the steps, but I think it was as described by
# this script.

# This division is done only so the Simplify and RemoveOverlap
# operations don't use up too much memory, and because
# a .sfd generated from the whole unifont.hex would be too big to
# process all at once.

all: ttf

#
# Commented out this operation on SFD file because not all applications
# correctly interpreted the settings:
#
#	    SetFontNames("UnifontMedium", "GNU", "Unifont", "Medium", $(COPYRIGHT), "$(VERSION)"); \
#
# Convert unifont.hex to unifont.sfd as a single file, then generate
# an outline TrueType font.
#
#
# SetFontNames(fontname[, family[, fullname[, weight[, copyright-notice[, fontversion]]]]])
#
ttf: $(FONTFILE).hex $(BINDIR)/hex2sfd
	@echo "Converting font as a single file."
	$(BINDIR)/hex2sfd $(COMBINING).txt < $(FONTFILE).hex > $(FONTFILE).sfd
	$(FONTFORGE) -lang=ff -c \
	   'Open($$1); \
	    SetFontNames("$(PSNAME)Medium", \
		"$(FONTNAME)", "$(FONTNAME)", "Medium", \
		$(COPYRIGHT)); \
	    SetTTFName($(TTF_LANG),  2, "Regular"); \
	    SetTTFName($(TTF_LANG),  5, "Version $(VERSION)"); \
	    SetTTFName($(TTF_LANG), 11, "https://unifoundry.com/unifont/"); \
	    SetTTFName($(TTF_LANG), 13, "Dual license: SIL Open Font License version 1.1, and GNU GPL version 2 or later with the GNU Font Embedding Exception."); \
	    SetTTFName($(TTF_LANG), 14, "https://gnu.org/licenses/gpl.html, https://scripts.sil.org/OFL"); \
	    SelectAll(); \
	    RemoveOverlap(); \
	    Simplify(64,1); \
	    Save($$1);' \
	   $(FONTFILE).sfd
	@echo "Converting .sfd font into .ttf font"
	$(FONTFORGE) -lang=ff -c \
	   'Open($$1); \
	    Generate($$2)' $(FONTFILE).sfd $(FONTFILE).ttf

#
# This fontforge script reads a BDF font file and generates an SBIT font file.
# Author: written by Qianqian Fang, given to Paul Hardy in 2008.
# The SBIT font is far smaller than the default outline TrueType font
# and takes far less time to build than the outline font.  However, it
# isn't scalable.  An SBIT font could be created and merged with the
# larger TTF font using fontforge, but I (Paul Hardy) haven't noticed
# any degradation in the screen rendering of just the outline TTF font
# that this Makefile produces as its final product.  This is with
# daily use of this Makefile's default TrueType font.
#
# This builds an SBIT font from the unifont_sample BDF font.  The
# BDF font already contains font name, etc., so they don't need to
# be set using SetFontNames; those parameters are left null so the
# existing font's values will be preserved.  However, Fontforge
# does not read the FONT_VERSION property so Paul Hardy added the
# the SetFontNames call.
#
# Commented out because not all applications correctly interpreted
# the settings:
#
#	    SetFontNames("","","","","","$(VERSION)"); \

sbit: $(FONTFILE).bdf
	$(FONTFORGE) -lang=ff -c \
	   'New(); \
	    Import($$1); \
	    SetFontNames("","","","","","$(VERSION)"); \
	    Generate($$2, "ttf"); \
	    Close()' \
	   $(FONTFILE).bdf $(FONTFILE).ttf
	rm -f $(FONTFILE).bdf

#
# Delete files copied into this directory to build TTF fonts.
#
clean:
	rm -f *.hex *.txt

#
# Delete files created within this directory while building TTF fonts.
#
distclean: clean
	rm -f *.sfd *.ttf

.PHONY: all ttf sbit clean distclean

=== font/plane00/hangul-johab1044/Makefile ===

#
# Directory where compiled C programs and Perl scripts are.
#
BINDIR=../../../bin

all: bin hangul-syllables.hex hangul-bmp ksx chojung

bin:
	if [ ! -d $(BINDIR) ] ; then \
	   (cd ../../.. ; make) ; \
	fi

# Convert the hanbase-??.bmp files into a Johab .hex file,
# then convert that into a BDF font file.
hangul-base.hex: hanbase-00.bmp hanbase-01.bmp hanbase-02.bmp
	echo "0000:0000000000000000000000000000000000000000000000000000000000000000" >hangul-base.hex
	$(BINDIR)/unibmp2hex -w < hanbase-00.bmp >>hangul-base.hex
	$(BINDIR)/unibmp2hex -w < hanbase-01.bmp >>hangul-base.hex
	$(BINDIR)/unibmp2hex -w < hanbase-02.bmp >>hangul-base.hex

hangul-base.bdf: hangul-base.hex
	$(BINDIR)/hex2bdf < hangul-base.hex > hangul-base.bdf

hangul-syllables.hex: bin hangul-base.bdf
	$(BINDIR)/johab2ucs2 < hangul-base.bdf > hangul-syllables.hex

# Convert the .hex file containing all Unicode Hangul Syllables
# into bitmap images for checking visually.

hangul-bmp: bin hangul-syllables.hex
	if [ ! -d syllables ]; then \
		mkdir syllables; \
	fi
	$(BINDIR)/unihex2bmp -pAC < hangul-syllables.hex > syllables/hangul-AC.bmp
	$(BINDIR)/unihex2bmp -pAD < hangul-syllables.hex > syllables/hangul-AD.bmp
	$(BINDIR)/unihex2bmp -pAE < hangul-syllables.hex > syllables/hangul-AE.bmp
	$(BINDIR)/unihex2bmp -pAF < hangul-syllables.hex > syllables/hangul-AF.bmp
	$(BINDIR)/unihex2bmp -pB0 < hangul-syllables.hex > syllables/hangul-B0.bmp
	$(BINDIR)/unihex2bmp -pB1 < hangul-syllables.hex > syllables/hangul-B1.bmp
	$(BINDIR)/unihex2bmp -pB2 < hangul-syllables.hex > syllables/hangul-B2.bmp
	$(BINDIR)/unihex2bmp -pB3 < hangul-syllables.hex > syllables/hangul-B3.bmp
	$(BINDIR)/unihex2bmp -pB4 < hangul-syllables.hex > syllables/hangul-B4.bmp
	$(BINDIR)/unihex2bmp -pB5 < hangul-syllables.hex > syllables/hangul-B5.bmp
	$(BINDIR)/unihex2bmp -pB6 < hangul-syllables.hex > syllables/hangul-B6.bmp
	$(BINDIR)/unihex2bmp -pB7 < hangul-syllables.hex > syllables/hangul-B7.bmp
	$(BINDIR)/unihex2bmp -pB8 < hangul-syllables.hex > syllables/hangul-B8.bmp
	$(BINDIR)/unihex2bmp -pB9 < hangul-syllables.hex > syllables/hangul-B9.bmp
	$(BINDIR)/unihex2bmp -pBA < hangul-syllables.hex > syllables/hangul-BA.bmp
	$(BINDIR)/unihex2bmp -pBB < hangul-syllables.hex > syllables/hangul-BB.bmp
	$(BINDIR)/unihex2bmp -pBC < hangul-syllables.hex > syllables/hangul-BC.bmp
	$(BINDIR)/unihex2bmp -pBD < hangul-syllables.hex > syllables/hangul-BD.bmp
	$(BINDIR)/unihex2bmp -pBE < hangul-syllables.hex > syllables/hangul-BE.bmp
	$(BINDIR)/unihex2bmp -pBF < hangul-syllables.hex > syllables/hangul-BF.bmp
	$(BINDIR)/unihex2bmp -pC0 < hangul-syllables.hex > syllables/hangul-C0.bmp
	$(BINDIR)/unihex2bmp -pC1 < hangul-syllables.hex > syllables/hangul-C1.bmp
	$(BINDIR)/unihex2bmp -pC2 < hangul-syllables.hex > syllables/hangul-C2.bmp
	$(BINDIR)/unihex2bmp -pC3 < hangul-syllables.hex > syllables/hangul-C3.bmp
	$(BINDIR)/unihex2bmp -pC4 < hangul-syllables.hex > syllables/hangul-C4.bmp
	$(BINDIR)/unihex2bmp -pC5 < hangul-syllables.hex > syllables/hangul-C5.bmp
	$(BINDIR)/unihex2bmp -pC6 < hangul-syllables.hex > syllables/hangul-C6.bmp
	$(BINDIR)/unihex2bmp -pC7 < hangul-syllables.hex > syllables/hangul-C7.bmp
	$(BINDIR)/unihex2bmp -pC8 < hangul-syllables.hex > syllables/hangul-C8.bmp
	$(BINDIR)/unihex2bmp -pC9 < hangul-syllables.hex > syllables/hangul-C9.bmp
	$(BINDIR)/unihex2bmp -pCA < hangul-syllables.hex > syllables/hangul-CA.bmp
	$(BINDIR)/unihex2bmp -pCB < hangul-syllables.hex > syllables/hangul-CB.bmp
	$(BINDIR)/unihex2bmp -pCC < hangul-syllables.hex > syllables/hangul-CC.bmp
	$(BINDIR)/unihex2bmp -pCD < hangul-syllables.hex > syllables/hangul-CD.bmp
	$(BINDIR)/unihex2bmp -pCE < hangul-syllables.hex > syllables/hangul-CE.bmp
	$(BINDIR)/unihex2bmp -pCF < hangul-syllables.hex > syllables/hangul-CF.bmp
	$(BINDIR)/unihex2bmp -pD0 < hangul-syllables.hex > syllables/hangul-D0.bmp
	$(BINDIR)/unihex2bmp -pD1 < hangul-syllables.hex > syllables/hangul-D1.bmp
	$(BINDIR)/unihex2bmp -pD2 < hangul-syllables.hex > syllables/hangul-D2.bmp
	$(BINDIR)/unihex2bmp -pD3 < hangul-syllables.hex > syllables/hangul-D3.bmp
	$(BINDIR)/unihex2bmp -pD4 < hangul-syllables.hex > syllables/hangul-D4.bmp
	$(BINDIR)/unihex2bmp -pD5 < hangul-syllables.hex > syllables/hangul-D5.bmp
	$(BINDIR)/unihex2bmp -pD6 < hangul-syllables.hex > syllables/hangul-D6.bmp
	$(BINDIR)/unihex2bmp -pD7 < hangul-syllables.hex > syllables/hangul-D7.bmp

#
# Extract those syllables that appear in KS X 1001:1992.
# These are the 2,350 syllables in modern usage out of
# a total possible 11,172 syllables.
#
ksx: bin hangul-syllables.hex
	if [ ! -d ksx-syllables ]; then \
		mkdir ksx-syllables; \
	fi
	$(BINDIR)/unifontksx < hangul-syllables.hex > ksx-syllables.hex
	$(BINDIR)/unihex2bmp -pAC < ksx-syllables.hex > ksx-syllables/han-AC.bmp
	$(BINDIR)/unihex2bmp -pAD < ksx-syllables.hex > ksx-syllables/han-AD.bmp
	$(BINDIR)/unihex2bmp -pAE < ksx-syllables.hex > ksx-syllables/han-AE.bmp
	$(BINDIR)/unihex2bmp -pAF < ksx-syllables.hex > ksx-syllables/han-AF.bmp
	$(BINDIR)/unihex2bmp -pB0 < ksx-syllables.hex > ksx-syllables/han-B0.bmp
	$(BINDIR)/unihex2bmp -pB1 < ksx-syllables.hex > ksx-syllables/han-B1.bmp
	$(BINDIR)/unihex2bmp -pB2 < ksx-syllables.hex > ksx-syllables/han-B2.bmp
	$(BINDIR)/unihex2bmp -pB3 < ksx-syllables.hex > ksx-syllables/han-B3.bmp
	$(BINDIR)/unihex2bmp -pB4 < ksx-syllables.hex > ksx-syllables/han-B4.bmp
	$(BINDIR)/unihex2bmp -pB5 < ksx-syllables.hex > ksx-syllables/han-B5.bmp
	$(BINDIR)/unihex2bmp -pB6 < ksx-syllables.hex > ksx-syllables/han-B6.bmp
	$(BINDIR)/unihex2bmp -pB7 < ksx-syllables.hex > ksx-syllables/han-B7.bmp
	$(BINDIR)/unihex2bmp -pB8 < ksx-syllables.hex > ksx-syllables/han-B8.bmp
	$(BINDIR)/unihex2bmp -pB9 < ksx-syllables.hex > ksx-syllables/han-B9.bmp
	$(BINDIR)/unihex2bmp -pBA < ksx-syllables.hex > ksx-syllables/han-BA.bmp
	$(BINDIR)/unihex2bmp -pBB < ksx-syllables.hex > ksx-syllables/han-BB.bmp
	$(BINDIR)/unihex2bmp -pBC < ksx-syllables.hex > ksx-syllables/han-BC.bmp
	$(BINDIR)/unihex2bmp -pBD < ksx-syllables.hex > ksx-syllables/han-BD.bmp
	$(BINDIR)/unihex2bmp -pBE < ksx-syllables.hex > ksx-syllables/han-BE.bmp
	$(BINDIR)/unihex2bmp -pBF < ksx-syllables.hex > ksx-syllables/han-BF.bmp
	$(BINDIR)/unihex2bmp -pC0 < ksx-syllables.hex > ksx-syllables/han-C0.bmp
	$(BINDIR)/unihex2bmp -pC1 < ksx-syllables.hex > ksx-syllables/han-C1.bmp
	$(BINDIR)/unihex2bmp -pC2 < ksx-syllables.hex > ksx-syllables/han-C2.bmp
	$(BINDIR)/unihex2bmp -pC3 < ksx-syllables.hex > ksx-syllables/han-C3.bmp
	$(BINDIR)/unihex2bmp -pC4 < ksx-syllables.hex > ksx-syllables/han-C4.bmp
	$(BINDIR)/unihex2bmp -pC5 < ksx-syllables.hex > ksx-syllables/han-C5.bmp
	$(BINDIR)/unihex2bmp -pC6 < ksx-syllables.hex > ksx-syllables/han-C6.bmp
	$(BINDIR)/unihex2bmp -pC7 < ksx-syllables.hex > ksx-syllables/han-C7.bmp
	$(BINDIR)/unihex2bmp -pC8 < ksx-syllables.hex > ksx-syllables/han-C8.bmp
	$(BINDIR)/unihex2bmp -pC9 < ksx-syllables.hex > ksx-syllables/han-C9.bmp
	$(BINDIR)/unihex2bmp -pCA < ksx-syllables.hex > ksx-syllables/han-CA.bmp
	$(BINDIR)/unihex2bmp -pCB < ksx-syllables.hex > ksx-syllables/han-CB.bmp
	$(BINDIR)/unihex2bmp -pCC < ksx-syllables.hex > ksx-syllables/han-CC.bmp
	$(BINDIR)/unihex2bmp -pCD < ksx-syllables.hex > ksx-syllables/han-CD.bmp
	$(BINDIR)/unihex2bmp -pCE < ksx-syllables.hex > ksx-syllables/han-CE.bmp
	$(BINDIR)/unihex2bmp -pCF < ksx-syllables.hex > ksx-syllables/han-CF.bmp
	$(BINDIR)/unihex2bmp -pD0 < ksx-syllables.hex > ksx-syllables/han-D0.bmp
	$(BINDIR)/unihex2bmp -pD1 < ksx-syllables.hex > ksx-syllables/han-D1.bmp
	$(BINDIR)/unihex2bmp -pD2 < ksx-syllables.hex > ksx-syllables/han-D2.bmp
	$(BINDIR)/unihex2bmp -pD3 < ksx-syllables.hex > ksx-syllables/han-D3.bmp
	$(BINDIR)/unihex2bmp -pD4 < ksx-syllables.hex > ksx-syllables/han-D4.bmp
	$(BINDIR)/unihex2bmp -pD5 < ksx-syllables.hex > ksx-syllables/han-D5.bmp
	$(BINDIR)/unihex2bmp -pD6 < ksx-syllables.hex > ksx-syllables/han-D6.bmp
	$(BINDIR)/unihex2bmp -pD7 < ksx-syllables.hex > ksx-syllables/han-D7.bmp

#
# Extract those syllables that only contain choseong and
# jungseong (initial consonant plus vowel).
#
chojung: bin hangul-syllables.hex
	if [ ! -d chojung-syllables ]; then \
		mkdir chojung-syllables; \
	fi
	$(BINDIR)/unifontchojung < hangul-syllables.hex > chojung-syllables.hex
	$(BINDIR)/unihex2bmp -pAC < chojung-syllables.hex > chojung-syllables/han-AC.bmp
	$(BINDIR)/unihex2bmp -pAD < chojung-syllables.hex > chojung-syllables/han-AD.bmp
	$(BINDIR)/unihex2bmp -pAE < chojung-syllables.hex > chojung-syllables/han-AE.bmp
	$(BINDIR)/unihex2bmp -pAF < chojung-syllables.hex > chojung-syllables/han-AF.bmp
	$(BINDIR)/unihex2bmp -pB0 < chojung-syllables.hex > chojung-syllables/han-B0.bmp
	$(BINDIR)/unihex2bmp -pB1 < chojung-syllables.hex > chojung-syllables/han-B1.bmp
	$(BINDIR)/unihex2bmp -pB2 < chojung-syllables.hex > chojung-syllables/han-B2.bmp
	$(BINDIR)/unihex2bmp -pB3 < chojung-syllables.hex > chojung-syllables/han-B3.bmp
	$(BINDIR)/unihex2bmp -pB4 < chojung-syllables.hex > chojung-syllables/han-B4.bmp
	$(BINDIR)/unihex2bmp -pB5 < chojung-syllables.hex > chojung-syllables/han-B5.bmp
	$(BINDIR)/unihex2bmp -pB6 < chojung-syllables.hex > chojung-syllables/han-B6.bmp
	$(BINDIR)/unihex2bmp -pB7 < chojung-syllables.hex > chojung-syllables/han-B7.bmp
	$(BINDIR)/unihex2bmp -pB8 < chojung-syllables.hex > chojung-syllables/han-B8.bmp
	$(BINDIR)/unihex2bmp -pB9 < chojung-syllables.hex > chojung-syllables/han-B9.bmp
	$(BINDIR)/unihex2bmp -pBA < chojung-syllables.hex > chojung-syllables/han-BA.bmp
	$(BINDIR)/unihex2bmp -pBB < chojung-syllables.hex > chojung-syllables/han-BB.bmp
	$(BINDIR)/unihex2bmp -pBC < chojung-syllables.hex > chojung-syllables/han-BC.bmp
	$(BINDIR)/unihex2bmp -pBD < chojung-syllables.hex > chojung-syllables/han-BD.bmp
	$(BINDIR)/unihex2bmp -pBE < chojung-syllables.hex > chojung-syllables/han-BE.bmp
	$(BINDIR)/unihex2bmp -pBF < chojung-syllables.hex > chojung-syllables/han-BF.bmp
	$(BINDIR)/unihex2bmp -pC0 < chojung-syllables.hex > chojung-syllables/han-C0.bmp
	$(BINDIR)/unihex2bmp -pC1 < chojung-syllables.hex > chojung-syllables/han-C1.bmp
	$(BINDIR)/unihex2bmp -pC2 < chojung-syllables.hex > chojung-syllables/han-C2.bmp
	$(BINDIR)/unihex2bmp -pC3 < chojung-syllables.hex > chojung-syllables/han-C3.bmp
	$(BINDIR)/unihex2bmp -pC4 < chojung-syllables.hex > chojung-syllables/han-C4.bmp
	$(BINDIR)/unihex2bmp -pC5 < chojung-syllables.hex > chojung-syllables/han-C5.bmp
	$(BINDIR)/unihex2bmp -pC6 < chojung-syllables.hex > chojung-syllables/han-C6.bmp
	$(BINDIR)/unihex2bmp -pC7 < chojung-syllables.hex > chojung-syllables/han-C7.bmp
	$(BINDIR)/unihex2bmp -pC8 < chojung-syllables.hex > chojung-syllables/han-C8.bmp
	$(BINDIR)/unihex2bmp -pC9 < chojung-syllables.hex > chojung-syllables/han-C9.bmp
	$(BINDIR)/unihex2bmp -pCA < chojung-syllables.hex > chojung-syllables/han-CA.bmp
	$(BINDIR)/unihex2bmp -pCB < chojung-syllables.hex > chojung-syllables/han-CB.bmp
	$(BINDIR)/unihex2bmp -pCC < chojung-syllables.hex > chojung-syllables/han-CC.bmp
	$(BINDIR)/unihex2bmp -pCD < chojung-syllables.hex > chojung-syllables/han-CD.bmp
	$(BINDIR)/unihex2bmp -pCE < chojung-syllables.hex > chojung-syllables/han-CE.bmp
	$(BINDIR)/unihex2bmp -pCF < chojung-syllables.hex > chojung-syllables/han-CF.bmp
	$(BINDIR)/unihex2bmp -pD0 < chojung-syllables.hex > chojung-syllables/han-D0.bmp
	$(BINDIR)/unihex2bmp -pD1 < chojung-syllables.hex > chojung-syllables/han-D1.bmp
	$(BINDIR)/unihex2bmp -pD2 < chojung-syllables.hex > chojung-syllables/han-D2.bmp
	$(BINDIR)/unihex2bmp -pD3 < chojung-syllables.hex > chojung-syllables/han-D3.bmp
	$(BINDIR)/unihex2bmp -pD4 < chojung-syllables.hex > chojung-syllables/han-D4.bmp
	$(BINDIR)/unihex2bmp -pD5 < chojung-syllables.hex > chojung-syllables/han-D5.bmp
	$(BINDIR)/unihex2bmp -pD6 < chojung-syllables.hex > chojung-syllables/han-D6.bmp
	$(BINDIR)/unihex2bmp -pD7 < chojung-syllables.hex > chojung-syllables/han-D7.bmp

#
# The three bmp targets below will create the files hanbase-0[012].bmp 
# rom an input hangul-base.hex file.  Ordinarily, the hanbase-0?.bmp

=== font/plane00/hangul/Makefile ===
CC=gcc

CFLAGS = -g -O2

VERSION = 16.0.04

BINDIR=../../../bin

all: hangul-base.html hangul-syllables.hex hangul-syllables2.hex check man

hangul-base.hex: hangul-base.txt
	$(BINDIR)/hexdraw hangul-base.txt > hangul-base.hex
	for i in 0 1 2 3 4 ; do \
	   $(BINDIR)/unihex2bmp -p$$i < hangul-base.hex > hangul-0$$i.bmp ; \
	done

hangul-base.html: hangul-base.hex
	$(BINDIR)/unijohab2html < hangul-base.hex > hangul-base.html

hangul-syllables.hex: hangul-base.hex
	$(BINDIR)/unigen-hangul -i hangul-base.hex -o hangul-syllables.hex

hangul-syllables2.hex: hangul-base.hex
	$(BINDIR)/johab2syllables -i hangul-base.hex -o hangul-syllables2.hex

reference: hangul-syllables.hex hangul-base.html
	if [ ! -d reference ] ; then mkdir reference ; fi
	tar cf - hangul-syllables.hex hangul-base.html | \
	   (cd reference ; tar xpf -)
	touch reference

check: hangul-base.html hangul-syllables.hex check-overlaps

check-diffs: hangul-base.html hangul-syllables.hex hangul-syllables2.hex
	@echo ""
	@echo "Checking against reference files..."
	@echo ""
	- diff reference/hangul-base.html hangul-base.html
	- diff reference/hangul-syllables.hex hangul-syllables.hex

#
# Check for overlaps between syllable components.
# Print how many were found.  The key at the top
# of the HTML file contains 4 overlapping color
# codes, so subtract those 4 from the total.
#
check-overlaps:
	@$(eval OVERLAPS = `egrep "CCCC|CC00CC" hangul-base.html | wc -l`)
	@echo ""
	@echo "Checking for overlaps..."
	@if [ $(OVERLAPS) -ne 4 ] ; then \
	   echo "Cells with Overlaps Found:" ; \
	   expr $(OVERLAPS) - 4 || true ; \
	else \
	   echo "No Overlaps Found" ; \
	fi

clean:
	rm -f hangul-syllables.hex hangul-syllables2.hex

distclean: clean

.PHONY: all man check check-diffs check-overlaps clean dist distclean

=== font/plane00/alt/hangul/Makefile ===

#
# Directory where compiled C programs and Perl scripts are.
#
BINDIR=../../../../bin

all: bin hangul-syllables.hex hangul-bmp ksx chojung

bin:
	if [ ! -d $(BINDIR) ] ; then \
	   (cd ../../../.. ; make) ; \
	fi

#
# The three bmp targets below will create the files hanbase-0[012].bmp 
# rom an input hangul-base.hex file.  Ordinarily, the hanbase-0?.bmp
# files are used to create the hangul-base.hex file.  If you invoke
# these next three targets, make sure you intended to erase any existing
# hanbase-0?.bmp input files.
#
hanbase-00.bmp:
	if [ -f hangul-base.hex ] ; then \
	   $(BINDIR)/unihex2bmp -p0 < hangul-base.hex > hanbase-00.bmp ; \
	fi

hanbase-01.bmp:
	if [ -f hangul-base.hex ] ; then \
	   $(BINDIR)/unihex2bmp -p1 < hangul-base.hex > hanbase-01.bmp ; \
	fi

hanbase-02.bmp:
	if [ -f hangul-base.hex ] ; then \
	   $(BINDIR)/unihex2bmp -p2 < hangul-base.hex > hanbase-02.bmp ; \
	fi

# Convert the hanbase-??.bmp files into a Johab .hex file,
# then convert that into a BDF font file.
hangul-base.hex: hanbase-00.bmp hanbase-01.bmp hanbase-02.bmp
	echo "0000:0000000000000000000000000000000000000000000000000000000000000000" >hangul-base.hex
	$(BINDIR)/unibmp2hex -w < hanbase-00.bmp >>hangul-base.hex
	$(BINDIR)/unibmp2hex -w < hanbase-01.bmp >>hangul-base.hex
	$(BINDIR)/unibmp2hex -w < hanbase-02.bmp >>hangul-base.hex

hangul-base.bdf: hangul-base.hex
	$(BINDIR)/hex2bdf < hangul-base.hex > hangul-base.bdf

hangul-syllables.hex: bin hangul-base.bdf
	./johab2ucs2 < hangul-base.bdf > hangul-syllables.hex

# Convert the .hex file containing all Unicode Hangul Syllables
# into bitmap images for checking visually.

hangul-bmp: bin hangul-syllables.hex
	if [ ! -d syllables ]; then \
		mkdir syllables; \
	fi
	$(BINDIR)/unihex2bmp -pAC < hangul-syllables.hex > syllables/hangul-AC.bmp
	$(BINDIR)/unihex2bmp -pAD < hangul-syllables.hex > syllables/hangul-AD.bmp
	$(BINDIR)/unihex2bmp -pAE < hangul-syllables.hex > syllables/hangul-AE.bmp
	$(BINDIR)/unihex2bmp -pAF < hangul-syllables.hex > syllables/hangul-AF.bmp
	$(BINDIR)/unihex2bmp -pB0 < hangul-syllables.hex > syllables/hangul-B0.bmp
	$(BINDIR)/unihex2bmp -pB1 < hangul-syllables.hex > syllables/hangul-B1.bmp
	$(BINDIR)/unihex2bmp -pB2 < hangul-syllables.hex > syllables/hangul-B2.bmp
	$(BINDIR)/unihex2bmp -pB3 < hangul-syllables.hex > syllables/hangul-B3.bmp
	$(BINDIR)/unihex2bmp -pB4 < hangul-syllables.hex > syllables/hangul-B4.bmp
	$(BINDIR)/unihex2bmp -pB5 < hangul-syllables.hex > syllables/hangul-B5.bmp
	$(BINDIR)/unihex2bmp -pB6 < hangul-syllables.hex > syllables/hangul-B6.bmp
	$(BINDIR)/unihex2bmp -pB7 < hangul-syllables.hex > syllables/hangul-B7.bmp
	$(BINDIR)/unihex2bmp -pB8 < hangul-syllables.hex > syllables/hangul-B8.bmp
	$(BINDIR)/unihex2bmp -pB9 < hangul-syllables.hex > syllables/hangul-B9.bmp
	$(BINDIR)/unihex2bmp -pBA < hangul-syllables.hex > syllables/hangul-BA.bmp
	$(BINDIR)/unihex2bmp -pBB < hangul-syllables.hex > syllables/hangul-BB.bmp
	$(BINDIR)/unihex2bmp -pBC < hangul-syllables.hex > syllables/hangul-BC.bmp
	$(BINDIR)/unihex2bmp -pBD < hangul-syllables.hex > syllables/hangul-BD.bmp
	$(BINDIR)/unihex2bmp -pBE < hangul-syllables.hex > syllables/hangul-BE.bmp
	$(BINDIR)/unihex2bmp -pBF < hangul-syllables.hex > syllables/hangul-BF.bmp
	$(BINDIR)/unihex2bmp -pC0 < hangul-syllables.hex > syllables/hangul-C0.bmp
	$(BINDIR)/unihex2bmp -pC1 < hangul-syllables.hex > syllables/hangul-C1.bmp
	$(BINDIR)/unihex2bmp -pC2 < hangul-syllables.hex > syllables/hangul-C2.bmp
	$(BINDIR)/unihex2bmp -pC3 < hangul-syllables.hex > syllables/hangul-C3.bmp
	$(BINDIR)/unihex2bmp -pC4 < hangul-syllables.hex > syllables/hangul-C4.bmp
	$(BINDIR)/unihex2bmp -pC5 < hangul-syllables.hex > syllables/hangul-C5.bmp
	$(BINDIR)/unihex2bmp -pC6 < hangul-syllables.hex > syllables/hangul-C6.bmp
	$(BINDIR)/unihex2bmp -pC7 < hangul-syllables.hex > syllables/hangul-C7.bmp
	$(BINDIR)/unihex2bmp -pC8 < hangul-syllables.hex > syllables/hangul-C8.bmp
	$(BINDIR)/unihex2bmp -pC9 < hangul-syllables.hex > syllables/hangul-C9.bmp
	$(BINDIR)/unihex2bmp -pCA < hangul-syllables.hex > syllables/hangul-CA.bmp
	$(BINDIR)/unihex2bmp -pCB < hangul-syllables.hex > syllables/hangul-CB.bmp
	$(BINDIR)/unihex2bmp -pCC < hangul-syllables.hex > syllables/hangul-CC.bmp
	$(BINDIR)/unihex2bmp -pCD < hangul-syllables.hex > syllables/hangul-CD.bmp
	$(BINDIR)/unihex2bmp -pCE < hangul-syllables.hex > syllables/hangul-CE.bmp
	$(BINDIR)/unihex2bmp -pCF < hangul-syllables.hex > syllables/hangul-CF.bmp
	$(BINDIR)/unihex2bmp -pD0 < hangul-syllables.hex > syllables/hangul-D0.bmp
	$(BINDIR)/unihex2bmp -pD1 < hangul-syllables.hex > syllables/hangul-D1.bmp
	$(BINDIR)/unihex2bmp -pD2 < hangul-syllables.hex > syllables/hangul-D2.bmp
	$(BINDIR)/unihex2bmp -pD3 < hangul-syllables.hex > syllables/hangul-D3.bmp
	$(BINDIR)/unihex2bmp -pD4 < hangul-syllables.hex > syllables/hangul-D4.bmp
	$(BINDIR)/unihex2bmp -pD5 < hangul-syllables.hex > syllables/hangul-D5.bmp
	$(BINDIR)/unihex2bmp -pD6 < hangul-syllables.hex > syllables/hangul-D6.bmp
	$(BINDIR)/unihex2bmp -pD7 < hangul-syllables.hex > syllables/hangul-D7.bmp

#
# Extract those syllables that appear in KS X 1001:1992.
# These are the 2,350 syllables in modern usage out of
# a total possible 11,172 syllables.
#
ksx: bin hangul-syllables.hex
	if [ ! -d ksx-syllables ]; then \
		mkdir ksx-syllables; \
	fi
	$(BINDIR)/unifontksx < hangul-syllables.hex > ksx-syllables.hex
	$(BINDIR)/unihex2bmp -pAC < ksx-syllables.hex > ksx-syllables/han-AC.bmp
	$(BINDIR)/unihex2bmp -pAD < ksx-syllables.hex > ksx-syllables/han-AD.bmp
	$(BINDIR)/unihex2bmp -pAE < ksx-syllables.hex > ksx-syllables/han-AE.bmp
	$(BINDIR)/unihex2bmp -pAF < ksx-syllables.hex > ksx-syllables/han-AF.bmp
	$(BINDIR)/unihex2bmp -pB0 < ksx-syllables.hex > ksx-syllables/han-B0.bmp
	$(BINDIR)/unihex2bmp -pB1 < ksx-syllables.hex > ksx-syllables/han-B1.bmp
	$(BINDIR)/unihex2bmp -pB2 < ksx-syllables.hex > ksx-syllables/han-B2.bmp
	$(BINDIR)/unihex2bmp -pB3 < ksx-syllables.hex > ksx-syllables/han-B3.bmp
	$(BINDIR)/unihex2bmp -pB4 < ksx-syllables.hex > ksx-syllables/han-B4.bmp
	$(BINDIR)/unihex2bmp -pB5 < ksx-syllables.hex > ksx-syllables/han-B5.bmp
	$(BINDIR)/unihex2bmp -pB6 < ksx-syllables.hex > ksx-syllables/han-B6.bmp
	$(BINDIR)/unihex2bmp -pB7 < ksx-syllables.hex > ksx-syllables/han-B7.bmp
	$(BINDIR)/unihex2bmp -pB8 < ksx-syllables.hex > ksx-syllables/han-B8.bmp
	$(BINDIR)/unihex2bmp -pB9 < ksx-syllables.hex > ksx-syllables/han-B9.bmp
	$(BINDIR)/unihex2bmp -pBA < ksx-syllables.hex > ksx-syllables/han-BA.bmp
	$(BINDIR)/unihex2bmp -pBB < ksx-syllables.hex > ksx-syllables/han-BB.bmp
	$(BINDIR)/unihex2bmp -pBC < ksx-syllables.hex > ksx-syllables/han-BC.bmp
	$(BINDIR)/unihex2bmp -pBD < ksx-syllables.hex > ksx-syllables/han-BD.bmp
	$(BINDIR)/unihex2bmp -pBE < ksx-syllables.hex > ksx-syllables/han-BE.bmp
	$(BINDIR)/unihex2bmp -pBF < ksx-syllables.hex > ksx-syllables/han-BF.bmp
	$(BINDIR)/unihex2bmp -pC0 < ksx-syllables.hex > ksx-syllables/han-C0.bmp
	$(BINDIR)/unihex2bmp -pC1 < ksx-syllables.hex > ksx-syllables/han-C1.bmp
	$(BINDIR)/unihex2bmp -pC2 < ksx-syllables.hex > ksx-syllables/han-C2.bmp
	$(BINDIR)/unihex2bmp -pC3 < ksx-syllables.hex > ksx-syllables/han-C3.bmp
	$(BINDIR)/unihex2bmp -pC4 < ksx-syllables.hex > ksx-syllables/han-C4.bmp
	$(BINDIR)/unihex2bmp -pC5 < ksx-syllables.hex > ksx-syllables/han-C5.bmp
	$(BINDIR)/unihex2bmp -pC6 < ksx-syllables.hex > ksx-syllables/han-C6.bmp
	$(BINDIR)/unihex2bmp -pC7 < ksx-syllables.hex > ksx-syllables/han-C7.bmp
	$(BINDIR)/unihex2bmp -pC8 < ksx-syllables.hex > ksx-syllables/han-C8.bmp
	$(BINDIR)/unihex2bmp -pC9 < ksx-syllables.hex > ksx-syllables/han-C9.bmp
	$(BINDIR)/unihex2bmp -pCA < ksx-syllables.hex > ksx-syllables/han-CA.bmp
	$(BINDIR)/unihex2bmp -pCB < ksx-syllables.hex > ksx-syllables/han-CB.bmp
	$(BINDIR)/unihex2bmp -pCC < ksx-syllables.hex > ksx-syllables/han-CC.bmp
	$(BINDIR)/unihex2bmp -pCD < ksx-syllables.hex > ksx-syllables/han-CD.bmp
	$(BINDIR)/unihex2bmp -pCE < ksx-syllables.hex > ksx-syllables/han-CE.bmp
	$(BINDIR)/unihex2bmp -pCF < ksx-syllables.hex > ksx-syllables/han-CF.bmp
	$(BINDIR)/unihex2bmp -pD0 < ksx-syllables.hex > ksx-syllables/han-D0.bmp
	$(BINDIR)/unihex2bmp -pD1 < ksx-syllables.hex > ksx-syllables/han-D1.bmp
	$(BINDIR)/unihex2bmp -pD2 < ksx-syllables.hex > ksx-syllables/han-D2.bmp
	$(BINDIR)/unihex2bmp -pD3 < ksx-syllables.hex > ksx-syllables/han-D3.bmp
	$(BINDIR)/unihex2bmp -pD4 < ksx-syllables.hex > ksx-syllables/han-D4.bmp
	$(BINDIR)/unihex2bmp -pD5 < ksx-syllables.hex > ksx-syllables/han-D5.bmp
	$(BINDIR)/unihex2bmp -pD6 < ksx-syllables.hex > ksx-syllables/han-D6.bmp
	$(BINDIR)/unihex2bmp -pD7 < ksx-syllables.hex > ksx-syllables/han-D7.bmp

#
# Extract those syllables that only contain choseong and
# jungseong (initial consonant plus vowel).
#
chojung: bin hangul-syllables.hex
	if [ ! -d chojung-syllables ]; then \
		mkdir chojung-syllables; \
	fi
	$(BINDIR)/unifontchojung < hangul-syllables.hex > chojung-syllables.hex
	$(BINDIR)/unihex2bmp -pAC < chojung-syllables.hex > chojung-syllables/han-AC.bmp
	$(BINDIR)/unihex2bmp -pAD < chojung-syllables.hex > chojung-syllables/han-AD.bmp
	$(BINDIR)/unihex2bmp -pAE < chojung-syllables.hex > chojung-syllables/han-AE.bmp
	$(BINDIR)/unihex2bmp -pAF < chojung-syllables.hex > chojung-syllables/han-AF.bmp
	$(BINDIR)/unihex2bmp -pB0 < chojung-syllables.hex > chojung-syllables/han-B0.bmp
	$(BINDIR)/unihex2bmp -pB1 < chojung-syllables.hex > chojung-syllables/han-B1.bmp
	$(BINDIR)/unihex2bmp -pB2 < chojung-syllables.hex > chojung-syllables/han-B2.bmp
	$(BINDIR)/unihex2bmp -pB3 < chojung-syllables.hex > chojung-syllables/han-B3.bmp
	$(BINDIR)/unihex2bmp -pB4 < chojung-syllables.hex > chojung-syllables/han-B4.bmp
	$(BINDIR)/unihex2bmp -pB5 < chojung-syllables.hex > chojung-syllables/han-B5.bmp
	$(BINDIR)/unihex2bmp -pB6 < chojung-syllables.hex > chojung-syllables/han-B6.bmp
	$(BINDIR)/unihex2bmp -pB7 < chojung-syllables.hex > chojung-syllables/han-B7.bmp
	$(BINDIR)/unihex2bmp -pB8 < chojung-syllables.hex > chojung-syllables/han-B8.bmp
	$(BINDIR)/unihex2bmp -pB9 < chojung-syllables.hex > chojung-syllables/han-B9.bmp
	$(BINDIR)/unihex2bmp -pBA < chojung-syllables.hex > chojung-syllables/han-BA.bmp
	$(BINDIR)/unihex2bmp -pBB < chojung-syllables.hex > chojung-syllables/han-BB.bmp
	$(BINDIR)/unihex2bmp -pBC < chojung-syllables.hex > chojung-syllables/han-BC.bmp
	$(BINDIR)/unihex2bmp -pBD < chojung-syllables.hex > chojung-syllables/han-BD.bmp
	$(BINDIR)/unihex2bmp -pBE < chojung-syllables.hex > chojung-syllables/han-BE.bmp
	$(BINDIR)/unihex2bmp -pBF < chojung-syllables.hex > chojung-syllables/han-BF.bmp
	$(BINDIR)/unihex2bmp -pC0 < chojung-syllables.hex > chojung-syllables/han-C0.bmp
	$(BINDIR)/unihex2bmp -pC1 < chojung-syllables.hex > chojung-syllables/han-C1.bmp
	$(BINDIR)/unihex2bmp -pC2 < chojung-syllables.hex > chojung-syllables/han-C2.bmp
	$(BINDIR)/unihex2bmp -pC3 < chojung-syllables.hex > chojung-syllables/han-C3.bmp
	$(BINDIR)/unihex2bmp -pC4 < chojung-syllables.hex > chojung-syllables/han-C4.bmp
	$(BINDIR)/unihex2bmp -pC5 < chojung-syllables.hex > chojung-syllables/han-C5.bmp
	$(BINDIR)/unihex2bmp -pC6 < chojung-syllables.hex > chojung-syllables/han-C6.bmp
	$(BINDIR)/unihex2bmp -pC7 < chojung-syllables.hex > chojung-syllables/han-C7.bmp
	$(BINDIR)/unihex2bmp -pC8 < chojung-syllables.hex > chojung-syllables/han-C8.bmp
	$(BINDIR)/unihex2bmp -pC9 < chojung-syllables.hex > chojung-syllables/han-C9.bmp
	$(BINDIR)/unihex2bmp -pCA < chojung-syllables.hex > chojung-syllables/han-CA.bmp
	$(BINDIR)/unihex2bmp -pCB < chojung-syllables.hex > chojung-syllables/han-CB.bmp
	$(BINDIR)/unihex2bmp -pCC < chojung-syllables.hex > chojung-syllables/han-CC.bmp
	$(BINDIR)/unihex2bmp -pCD < chojung-syllables.hex > chojung-syllables/han-CD.bmp
	$(BINDIR)/unihex2bmp -pCE < chojung-syllables.hex > chojung-syllables/han-CE.bmp
	$(BINDIR)/unihex2bmp -pCF < chojung-syllables.hex > chojung-syllables/han-CF.bmp
	$(BINDIR)/unihex2bmp -pD0 < chojung-syllables.hex > chojung-syllables/han-D0.bmp

=== debian/changelog ===
unifont (1:16.0.04-1) unstable; urgency=medium

  * New upstream version 16.0.04
    - It can be built with gcc-15 (Closes: #1098039)
  * debian/control
    - Set Standards-Version: 4.7.2 with no changes
    - Add imagemagick to deal with upstream changes
  * debian/patches
    - Add set-LDFLAGS-and-CPPFLAGS.patch and use-default-cc.patch for hardening
  * debian/rules
    - With above patches, drop unnecessary lines.

 -- Hideki Yamane <henrich@debian.org>  Fri, 05 Sep 2025 17:58:51 +0900

=== debian/control ===
Source: unifont
Section: fonts
Priority: optional
Maintainer: Debian Fonts Task Force <debian-fonts@lists.debian.org>
Uploaders: Hideki Yamane <henrich@debian.org>
Build-Depends: debhelper-compat (= 13),
Build-Depends-Indep: fontforge-nox | fontforge, xfonts-utils, bdf2psf, libgd-perl, texinfo, imagemagick,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://unifoundry.com/unifont/
Vcs-Browser: https://salsa.debian.org/fonts-team/unifont
Vcs-Git: https://salsa.debian.org/fonts-team/unifont.git

Package: unifont
Architecture: all
Multi-Arch: foreign
Depends: fonts-unifont, psf-unifont, ${misc:Depends}
Recommends: xfonts-unifont,
Suggests: unifont-bin
Description: font with a glyph for each visible Unicode Plane 0 character
 This package is a convenient way to install the PCF bitmap version,
 PSF bitmap version, and the scalable OpenType outline version of "Unifont"
 (intended for general-purpose use) and "Unifont Sample" (which contains
 combining circles to use for illustration purposes).  It also installs
 a copy of unifont.hex and related files in /usr/share/unifont.
 .
 GNU Unifont was designed to render something besides an empty box
 for each visible Unicode character in the Basic Multilingual Plane
 (BMP, or Plane 0).  The BMP contains most of the world's modern writing
 scripts.  This font looks best at 12pt.
 .
 Complex fonts (such as Indic or Semitic scripts, where letters change
 shape depending on their position in a word, or such as Mongolian, which
 can be written vertically) will not render perfectly.  The philosophy
 behind this font, though, is that anything meaningful is better than
 an empty box for an unknown glyph.

Package: xfonts-unifont
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: fonts-unifont
Description: PCF (bitmap) version of GNU Unifont
 This contains three fonts: "Unifont" (unifont.pcf.gz),
 "Unifont CSUR" (unifont_csur.pcf.gz),  and
 "Unifont Sample" (unifont_sample.pcf.gz).
 .
 This is a bitmap version of Unifont in a standard X11 format.
 The fonts provide a glyph for each visible code point (character)
 in the Unicode Basic Multilingual Plane (BMP, or Plane 0).  The BMP
 contains most of the world's modern writing scripts.  These fonts
 look best at 12pt.
 .
 unifont.pcf.gz contains Unicode Plane 0 glyphs.  This is the main font.
 .
 unifont_sample.pcf.gz contains combining circles for combining characters.
 Thus it is suited for illustrating individual Unicode glyphs, whereas
 Unifont is intended for general-purpose writing.
 .
 unifont_csur.pcf.gz contains some scripts in the Plane 0 ConScript
 Unicode Registry (CSUR).  These scripts are not part of the Unicode
 Standard, but are a popular use for the Private Use Area (PUA).
 .
 Complex fonts (such as Indic or Semitic scripts, where letters change
 shape depending on their position in a word, or such as Mongolian, which
 can be written vertically) will not render perfectly.  The philosophy
 behind this font, though, is that anything meaningful is better than
 an empty box for an unknown glyph.
 .
 Consider using the OpenType version instead (fonts-unifont), because
 that version is scalable to any point size and has proper combining
 character support.

Package: fonts-unifont
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Replaces: ttf-unifont (<< 1:13.0.02-1)
Breaks: ttf-unifont (<< 1:13.0.02-1)
Description: OpenType version of GNU Unifont
 This contains five fonts: "Unifont", "Unifont Upper", "Unifont CSUR",
 "Unifont JP" and "Unifont Sample".
 .
 unifont.otf is a bitmap font converted into a scalable OpenType
 outline font, Unifont.  Each pixel in the original bitmap font
 is represented as an outlined square.  The font provides a glyph
 for each visible code point (character) in the Unicode Basic
 Multilingual Plane (BMP, or Plane 0).  The BMP contains most of
 the world's modern writing scripts.  This font looks best at 12pt.
 .
 unifont_upper.otf is a bitmap font converted into a scalable OpenType
 outline font that covers Unicode ranges above Plane 0.  Most of its
 glyphs are in Plane 1, the Unicode Supplemental Multilingual Plane (SMP).
 .
 unifont_csur.otf is a bitmap font converted into a scalable OpenType
 outline font that contains some scripts in the ConScript Unicode
 Registry (CSUR).  These scripts are not part of the Unicode Standard,
 but are a popular use for the Private Use Area (PUA).  This font
 contains glyphs in Plane 0 and in the higher PUA planes.
 .
 unifont_jp.otf is a scalable OpenType outline font that contains
 Unicode Plane 2 glyphs that appear in JIS X 0213.
 .
 unifont_sample.otf is an SBIT font that contains combining circles
 and is therefore suitable for illustrating individual Unicode glyphs.
 The other font files do not contain combining circles and so are suitable
 for general-purpose writing.
 .
 Complex fonts (such as Indic or Semitic scripts, where letters change
 shape depending on their position in a word, or such as Mongolian, which
 can be written vertically) will not render perfectly.  The philosophy
 behind this font, though, is that anything meaningful is better than
 an empty box for an unknown glyph.

Package: psf-unifont
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: fonts-unifont
Description: PSF (console) version of GNU Unifont with APL support
 This contains a PSF font (Unifont-APL8x16.psf) as a console frame
 buffer font with a subset of Unifont for use with GNU APL and other
 APL implementations.  The font is installed in "/usr/share/consolefonts/".
 This PSF font is only suitable for running in console mode, not under the
 X Window System.
 .
 A PSF font allows a maximum of 512 glyphs.  The glyph subset in this
 font includes ASCII, Latin-1, "oe" and "OE" ligatures for French, the
 Euro sign, Unicode Box Drawing, Unicode Block Elements, plus various
 glyphs for APL support and some other miscellaneous glyphs.  The font
 is monospaced, 8 pixels wide by 16 pixels tall.
 .
 Consider using the OpenType version instead (fonts-unifont) if you are
 not running in console mode, because that version is scalable to any
 point size and has proper combining character support.

Package: unifont-bin
Architecture: any
Depends: xfonts-utils, bdf2psf, fontforge, ${shlibs:Depends}, ${misc:Depends},
 ${perl:Depends}, libwx-perl, libgd-perl
Suggests: unifont, texinfo, texlive
Description: utilities for manipulating GNU Unifont
 This is a set of Perl scripts, C programs, and FontForge scripts
 to manipulate Roman Czyborra's GNU Unifont ".hex" format font
 files.  GNU Unifont has a Unicode-compatible font structure.
 These utilities allow editing ".hex" fonts with text and
 graphical editors, producing final versions of fonts in BDF,
 PCF, PSF, TrueType SBIT, and TrueType outline formats.
 .
 To build the TrueType fonts, install the package 'fontforge'.  To build
 the PCF fonts, use 'bdftopcf', which is in the 'xfonts-utils' package.
 To build the PSF font, use 'bdf2psf', which is in the 'console-setup'
 package.  To obtain the font sources, run 'apt source unifont'.
 .
 Building the main Unifont TrueType font will require at least 4 GB of
 main memory.  You only need texlive (~1 GB) if you want to rebuild the
 unifont.pdf file in doc/ (see doc/Makefile); this is not done by default.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
CFLAGS   = -Wall $(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS  = $(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@

# The below build-indep target is the default way that Unifont
# is built, and is already in the "font/precompiled/" directory.
#
# BUILDFONT=1 forces the building of the font from the contents of
# "font/plane00/*.hex".  The results will be in the "font/compiled/"
# directory.  The font files in that directory will get installed
# in preference to the files in the "font/precompiled/" directory
# if both exist.
#
# PUA="" makes sure that the glyphs in "font/plane00/pua.hex" don't
# get built into the final font, though that is the default behavior.
# The flag is there also as a placeholder for building a custom
# font with a special set of PUA glyphs if desired.
#
# If the build-indep rule is commented out, then Unifont is installed
# from the pre-built files in the "font/precompiled/" directory, which
# should be identical to the files that this rule builds.
#
override_dh_auto_build-indep:
	$(MAKE) BUILDFONT=1 PUA=""

override_dh_auto_install-arch:
	dh_auto_install --builddirectory=src -- PREFIX='$$(DESTDIR)/usr'
	dh_auto_install --builddirectory=man -- PREFIX='$$(DESTDIR)/usr'

#
# Exclude ChangeLog until dh_installchangelogs is updated,
# to comply with Debian Policy Version 4.2.0.
#
override_dh_installchangelogs:
	dh_installchangelogs --exclude=ChangeLog
